"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _helpers = require("../helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var Tab = function Tab(_ref) {
  var classList = _ref.classList,
      type = _ref.type,
      selected = _ref.selected,
      closable = _ref.closable,
      disabled = _ref.disabled,
      tabClickHandler = _ref.tabClickHandler,
      tabCloseHandler = _ref.tabCloseHandler,
      children = _ref.children;
  return _react["default"].createElement("li", {
    className: (0, _helpers.classNames)([].concat(_toConsumableArray(classList), ['tab-header', type, selected ? 'active' : '', closable ? 'closable' : '', disabled ? 'disabled' : ''])),
    onClick: disabled ? undefined : tabClickHandler,
    onKeyPress: disabled ? undefined : tabClickHandler
  }, children, closable && _react["default"].createElement("span", {
    role: "button",
    tabIndex: -1,
    className: "close-tab",
    onClick: function onClick(e) {
      e.stopPropagation();
      if (typeof tabCloseHandler === 'function') tabCloseHandler();
    },
    onKeyPress: function onKeyPress() {
      return typeof tabCloseHandler === 'function' && tabCloseHandler();
    }
  }, "\u2715"));
};

Tab.tabRole = 'Tab';
var _default = Tab;
exports["default"] = _default;