"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// import '../../styles/tabs.scss'
var TYPE = {
  ADD_TAB: 'add-tab'
};

var nodeType = function nodeType(element) {
  return element ? element.type.tabRole : undefined;
};

var TabbedContent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TabbedContent, _React$Component);

  function TabbedContent(props) {
    var _this;

    _classCallCheck(this, TabbedContent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TabbedContent).call(this, props));
    _this.isStateful = !props.stateless; // used for delegating tab selections higher up (redux)

    if (_this.isStateful) {
      _this.state = {
        selectedTab: props.selectedTab
      };
    }

    _this.selectTab = _this.selectTab.bind(_assertThisInitialized(_this));
    _this.getTabClickHandler = _this.getTabClickHandler.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(TabbedContent, [{
    key: "render",
    value: function render() {
      var className = this.props.className;
      return _react["default"].createElement("div", {
        className: "tabbed-content ".concat(className)
      }, this.getChildren());
    }
  }, {
    key: "selectTab",
    value: function selectTab(tabId) {
      if (this.isStateful) {
        this.setState({
          selectedTab: tabId
        });
      }
    }
  }, {
    key: "getSelectedTab",
    value: function getSelectedTab() {
      var isStateful = this.isStateful,
          state = this.state,
          props = this.props;
      return isStateful ? state.selectedTab : props.selectedTab;
    } // using id and not tab.props.tabId as this might not be set
    // in which case we would rely on auto-incremented index instead

  }, {
    key: "getTabClickHandler",
    value: function getTabClickHandler(tab, id) {
      var _this2 = this;

      if (tab.props && tab.props.type === TYPE.ADD_TAB) {
        return tab.props.tabClickHandler;
      }

      return function (event) {
        if (typeof tab.props.tabClickHandler === 'function') {
          tab.props.tabClickHandler(event);
        }

        if (!tab.props.preventDefaultTabAction) {
          _this2.selectTab(id);
        }
      };
    }
  }, {
    key: "getChildren",
    value: function getChildren() {
      var _this3 = this;

      var children = this.props.children;
      var tabIndex = 0;
      var tabContentIndex = 0;
      var defaultSelected;
      return _react["default"].Children.map(children, function (child) {
        if (nodeType(child) === 'TabList') {
          return (0, _react.cloneElement)(child, {
            children: _react["default"].Children.map(child.props.children, function (innerChild) {
              if (nodeType(innerChild) === 'Tab') {
                var id = innerChild.props.tabId || tabIndex++;

                if (defaultSelected === undefined && !_this3.getSelectedTab() && !innerChild.props.disabled) {
                  defaultSelected = id;
                }

                return (0, _react.cloneElement)(innerChild, _objectSpread({}, innerChild.props, {
                  id: id,
                  selected: id === _this3.getSelectedTab() || defaultSelected === id,
                  tabClickHandler: _this3.getTabClickHandler(innerChild, id),
                  classList: innerChild.props.className ? innerChild.props.className.split(' ') : []
                }));
              }

              return innerChild;
            })
          });
        }

        if (nodeType(child) === 'TabContent') {
          var id = child.props.tabId || tabContentIndex++;
          return (0, _react.cloneElement)(child, _objectSpread({}, child.props, {
            id: id,
            selected: id === _this3.getSelectedTab() || defaultSelected === id,
            classList: child.props.className ? child.props.className.split(' ') : []
          }));
        }

        return child;
      });
    }
  }]);

  return TabbedContent;
}(_react["default"].Component);

TabbedContent.TYPE = TYPE;
var _default = TabbedContent;
exports["default"] = _default;