import React from 'react';
import { classNames } from '../helpers';

const Tab = ({
  classList,
  type,
  selected,
  closable,
  disabled,
  tabClickHandler,
  tabCloseHandler,
  children,
}) => (
  <li
    className={classNames([
      ...classList,
      'tab-header',
      type,
      selected ? 'active' : '',
      closable ? 'closable' : '',
      disabled ? 'disabled' : '',
    ])}
    onClick={disabled ? undefined : tabClickHandler}
    onKeyPress={disabled ? undefined : tabClickHandler}
  >
    {children}
    {
      closable &&
      (
      <span
        role="button"
        tabIndex={-1}
        className="close-tab"
        onClick={(e) => {
          e.stopPropagation();
          if (typeof tabCloseHandler === 'function') tabCloseHandler();
        }}
        onKeyPress={() => typeof tabCloseHandler === 'function' && tabCloseHandler()}
      >
      &#10005;
      </span>
      )
    }
  </li>
);

Tab.tabRole = 'Tab';

export default Tab;
